#ifndef _RQA_RUNNER_H
#define _RQA_RUNNER_H
/*
  $Id: applet_runner.h,v 1.1 2006/07/15 08:48:38 noir Exp $
  Copyright (C) 2006 Hiroyuki KUROSAKI <noir (at) st . rim . or . jp>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <qpe/qpeapplication.h>
#include <qobject.h>
#include <qstring.h>
#include <qpe/qcopenvelope_qws.h>
#include "ruby.h"

namespace RubyQpeApplet
{

class AppletRunner : public QPEApplication
{
    Q_OBJECT
public:
    AppletRunner(const QString& applet_file_name,
                 const QString& applet_class_name,
                 const QString& log_file_name,
                 int argc, char *argv[]);
    ~AppletRunner();
    void       run(bool as_main_widget);

private:
    VALUE      ruby_runner;
    int        ruby_state;
    void       init_ruby_runner(const QString& applet_file_name,
                                const QString& applet_class_name,
                                const QString& log_file_name);
    void       finalize_ruby_runner();
    void       init_qcop_channel();

protected:
    QCopChannel* qcop_channel;

protected slots:
    void receive_message(const QCString& msg, const QByteArray& data);
    void redirect_click();
};

};


#endif /* _RQA_RUNNER_H */
